program PCMAGX;
{$APPTYPE CONSOLE}
uses
  SysUtils,classes;

var f, g : text; // input & output files
    S, COMM : String;
    SL : TStringList; //  incoming strings queued
    i : Integer;
    lex : array of Integer; // array for the lex-order -> SL[lex[0]]<SL[lex[1]]<...

// binary search for S in SL
function  IndexOfS : Integer;
var i, j, k : Integer;
begin
  i:=0;j:=SL.Count;
  While i<j Do
    Begin
      k:=(i+j) div 2;
      if SL[lex[k]]<S Then i:=k+1
                      Else j:=k;
    End;
  Result:=i;
end;

// ADDs S to SL and updates lex
procedure DO_ADD;
var i,j : integer;
begin
  i:=IndexOfS;
  if (i<SL.Count) and (S=SL[lex[i]])
        Then WriteLn(g,'DUPLICATES NOT ALLOWED')
        Else Begin
               SL.Add(S);
               SetLength(lex,SL.Count+1);
               for j:=SL.Count downto i+1 do
                   lex[j]:=lex[j-1];
               lex[i]:=SL.Count-1;

               WriteLn(g,'ADDED: '+S);
             End;
end;

// binary search for S in SL
procedure DO_FS;
var i : integer;
begin
  i:=IndexOfS;
  if (i<SL.Count) and (S=SL[lex[i]])
        Then WriteLn(g,'FOUND: '+inttostr(lex[i]+1))
        Else WriteLn(g,'NOT FOUND');
end;

// writes the required SL string to g
procedure DO_FNL;
var i : integer;
begin
  i:=strtointdef(S,-1);
  if i<1 Then WriteLn(g,'SYNTAX ERROR')
   else if i>SL.Count Then WriteLn(g,'NOT FOUND')
     else if COMM='FN' then WriteLn(g,'FOUND: '+SL[i-1])
                       else WriteLn(g,'FOUND: '+SL[lex[i-1]]);
end;

// deletes i-th string from SL and updates lex
procedure DO_DELETE(i : Integer);
var j, l : Integer;
begin
  SL.Delete(i-1);
  for j:=0 to SL.Count do
              if lex[j]>=i Then Dec(lex[j])
                           Else if lex[j]=i-1 Then l:=j;
  for j:=l to SL.Count-1 do
    lex[j]:=lex[j+1];
End;

// deletes S from SL
procedure DO_DS;
var i : integer;
begin
  i:=IndexOfS;
  if (i<SL.Count) and (S=SL[lex[i]])
        Then Begin
               WriteLn(g,'DELETED: '+inttostr(lex[i]+1));
               DO_DELETE(lex[i]+1);
             End
        Else WriteLn(g,'NOT FOUND');
end;

// deletes the string with specified index/lex-index from SL
procedure DO_DNL;
var i : integer;
begin
  i:=strtointdef(S,-1);
  if i<1 Then WriteLn(g,'SYNTAX ERROR')
   else if i>SL.Count Then WriteLn(g,'NOT FOUND')
     else Begin
            if COMM='DL' Then i:=lex[i-1]+1;
            WriteLn(g,'DELETED: '+SL[i-1]);
            DO_DELETE(i);
          End;
end;


BEGIN
  SL:=TStringList.Create;
  SetLength(lex,1);

  Assign(f,'CATALOG.INP');
  {$i-}
  Reset(f);
  {$i+}
  if IORESULT<>0 Then Halt;

  Assign(g,'CATALOG.OUT');
  Rewrite(g);
  While not Eof(f) Do
    Begin
      Readln(f,S);
      i:=Pos(' ',S);

      if (Length(S)<4) or (i<3) or (S[Length(S)]=' ') Then Writeln(g,'SYNTAX ERROR')
         Else Begin
                COMM:=Copy(S,1,i-1);
                Delete(S,1,i);
                if S[1]=' ' Then WriteLn(g,'SYNTAX ERROR')
                  else if COMM='ADD' then DO_ADD
                   else if COMM='FS' Then DO_FS
                    else if (COMM='FN') or (COMM='FL') Then DO_FNL
                     else if COMM='DS' Then DO_DS
                      else if (COMM='DN') or (COMM='DL') Then DO_DNL
                       else WriteLn(g,'SYNTAX ERROR');
              End;
    End;
  Close(g);
  Close(f);
end.