// ZadDB.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include "gsidb.h"


#define FNAME_IN "catalog.inp"
#define FNAME_OUT "catalog.out"
#define COMM_STD //printf ("Command: %s Parameter:%s^\n",comm,str)
#define COMM_STDI //printf ("Command: %s Parameter:%i^\n",comm,par)
#define COMM_FILE fprintf(fout,"Command: %s Parameter:%s^\n",comm,str) 
#define PRINT_COMM COMM_STD
#define PRINT_STD puts ("SYNTAX ERROR")
#define PRINT_FILE fputs ("SYNTAX ERROR\n",fout)
#define SYNTAX_ERR PRINT_FILE;\
		return;

#define TOINT(par) char* stopstr;\
					par=strtol (str,&stopstr,10)

#define STR2OUT(text,str) fprintf (fout,"%s %s\n",text,str)
#define INT2OUT(text,str) fprintf (fout,"%s %i\n",text,str)

CGsiDB* GsiDB;
DWORD elcount=0;

void procline (FILE* fout,char* line)
{
	
	int linesize=0,cs=0;
	while ((line[linesize]!='\n')&&(line[linesize]))
	{
		if ((line[linesize]==' ')&&!cs)
			cs=linesize;
		linesize++;
	}
	line [linesize]=0;
	if (cs>3)
	{
		SYNTAX_ERR;
	}
	line [cs]=0;
	char* comm=line;
	char* str=line+cs+1;
	if ((line[linesize-1]==' ')||(str[0]==' '))
	{
		SYNTAX_ERR;
	}
	
	
	
	
	
	
	if (!strcmp (comm, "ADD"))
	{
		COMM_STD;
		CInData indata (str,NULL,elcount+1);
		if (GsiDB->Add (indata))
		{
			STR2OUT ("ADDED:",str);
			elcount++;
		}
		else
		{
			STR2OUT ("DUPLICATES","NOT ALLOWED");

		}
		return;
	}

	if (!strcmp (comm, "FS"))
	{
		COMM_STD;
		DWORD res;
		if (GsiDB->Get (str,&res))
			INT2OUT ("FOUND:",res);
		else
			STR2OUT("NOT","FOUND");
		return;
	}
	if (!strcmp (comm, "FN"))
	{
		
		DWORD par;
		TOINT(par);
		if (!par)
		{
			SYNTAX_ERR;
		}
		COMM_STDI;
		char* ret=NULL;
		if ((ret=GsiDB->GetEN (par)))
			STR2OUT ("FOUND:",ret);
		else
			STR2OUT("NOT","FOUND");


		
		return;
	}
	if (!strcmp (comm, "FL"))
	{
		DWORD par;
		TOINT(par);
		if (!par)
		{
			SYNTAX_ERR;
		}
		COMM_STDI;
		char ret[255]={0};
		BOOL res=GsiDB->GetLN (par,ret);
		if (res)
			STR2OUT ("FOUND:",ret);
		else
			STR2OUT("NOT","FOUND");
		
		
		
		return;
	}
	if (!strcmp (comm, "DS"))
	{
		COMM_STD;
		DWORD res;
		if (res=GsiDB->Delete (str))
			INT2OUT ("DELETED:",res);
		else
			STR2OUT("NOT","FOUND");
		return;
	}
	if (!strcmp (comm, "DN"))
	{
		DWORD par;
		TOINT(par);
		if (!par)
		{
			SYNTAX_ERR;
		}
		COMM_STDI;
		char* ret=NULL;
		if ((ret=GsiDB->DeleteEN (par)))
			STR2OUT ("DELETED:",ret);
		else
			STR2OUT("NOT","FOUND");
		
		return;
	}
	if (!strcmp (comm, "DL"))
	{
		DWORD par;
		TOINT(par);
		if (!par)
		{
			SYNTAX_ERR;
		}
		COMM_STDI;
		char ret[255]={0};
		BOOL res=GsiDB->DeleteLN (par,ret);
		if (res)
			STR2OUT ("DELETED:",ret);
		else
			STR2OUT("NOT","FOUND");
		
		return;
	}	
	
	SYNTAX_ERR;
	
	

	
}
int main(int argc, char* argv[])
{
	FILE* fin;
	FILE* fout;
	char line[256]={0};
	
	GsiDB=new CGsiDB ("noname"); 
	fout=fopen (FNAME_OUT,"w");
	puts ("Working...");
	if (!(fin=fopen (FNAME_IN,"r")))
	{
		printf ("file open error\n");
		return 0;
	}
	while (!feof(fin))
	{
		fgets (line,255,fin);
		procline (fout,line);
	}
	fclose (fin);
	fclose (fout);
	puts ("Done. Releasing used memory... ");
	
	delete GsiDB;
	return 0;
}
