
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the GSIDB_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// GSIDB_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef GSIDB_EXPORTS
#define GSIDB_API //__declspec(dllexport)
#else
#define GSIDB_API //__declspec(dllimport)
#endif

// This class is exported from the gsiDB.dll
#define MAX_DWORD 0xFFFFFFFF
#define CHUNK_CAP 102400//25600
#define CHUNK_SIZE CHUNK_CAP*4

class GSIDB_API CArrayPtr {
private:
	DWORD count;
	DWORD* data;
public:
	CArrayPtr();
	~CArrayPtr ();
	BOOL  Add (void* Element);
	void* GetAt (DWORD i);
	DWORD GetCount ();

};

class GSIDB_API CKeyData {
	char FileName[100];
	DWORD FileInx;
	DWORD KeyInx;
	DWORD IntFileName;

public:
	CKeyData(DWORD FName,DWORD FInx){sprintf(FileName,"%u.dat",FName);FileInx=FInx;IntFileName=FName;}
	CKeyData(DWORD FName,DWORD FInx,DWORD KInx){sprintf(FileName,"%u.dat",FName);FileInx=FInx;KeyInx=KInx;IntFileName=FName;}
	void SetFileName( DWORD FName){sprintf(FileName,"%u.dat",FName);}
	void SetFileInx (DWORD FInx){FileInx=FInx;}
	char* GetFileName (){return FileName;}
	DWORD GetFileInx(){return FileInx;}
	DWORD GetKeyInx(){return KeyInx;}
	void SetKeyInx (DWORD KInx){KeyInx=KInx;}
	DWORD GetIntFileName (){return IntFileName;}
	

	
};

class GSIDB_API CLetter {
public:
	CLetter ();
	CLetter(char ch);
	CLetter(char ch,CLetter* next,CLetter* same);
	CLetter* Next;
	CLetter*  Same;
	char letter;
	DWORD data;
	DWORD count;
};


class GSIDB_API CTray {
	CLetter* head;	
	char Char2Inx(char ch);
	BOOL DynamicData;

public:
	void RemoveAll ();
	CTray ();
	CTray (BOOL DD);
	~CTray ();
	void SetDD (BOOL DD);
	BOOL Add(char* word,DWORD data);
	BOOL Delete(char* word,DWORD* data);
	BOOL Get(char* word,DWORD* data);
	BOOL GetN(DWORD Num,char* word,DWORD* data);
	BOOL DeleteN(DWORD Num,char* word,DWORD* data);

private:
	void Clear(CLetter* cur);
	void Find (CLetter* prev,CLetter* cur,int i,char* word,BOOL* found,DWORD* data);
	void Del (CLetter* prev,CLetter* cur,int i,char* word,BOOL* found,DWORD* data);
	void FindN (CLetter* prev,CLetter* cur,int i,DWORD Num,char* word,BOOL* found,DWORD* data,DWORD* curword);
};


class GSIDB_API CInData {
	char key[100];
	char keysize;

public:
	void *data;
	DWORD size;


	CInData (char* keyp,void* datap,DWORD Size);
	void SetKey(char* keyp);
	char* GetKey ();
	char GetKeySize();
	BOOL SaveKey2File (HANDLE hFile,CKeyData keydata);

};
	

class GSIDB_API CDelNum {
public:
	CDelNum (){Num=0;Next=NULL;}
	CDelNum (CDelNum* next,DWORD num){Num=num;Next=next;}
	~CDelNum(){}
	DWORD Num;
	CDelNum* Next;
};

class GSIDB_API CDelArray {
private:
	CDelNum* first;
	DWORD count;
	void Clear ();
public:
	CDelArray (){first=NULL;}
	~CDelArray (){Clear ();}
	void  Add (DWORD num);
	DWORD Correction  (DWORD num);

};

class GSIDB_API CNames {
public:
	CNames ();
	~CNames ();
	void Add (char* name,int Size);
	void Delete (DWORD num){delete data[num];data[num]=NULL;}
	char* Get (DWORD num) {return (num>count)?NULL:data[num];}
private:
	DWORD count;
	DWORD size;
	DWORD cap;
	char** data;
};

class GSIDB_API CGsiDB {
private:
	BOOL ReindexKeys (DWORD FileN,DWORD FileI,DWORD ElS);
	CKeyData* FindNextInx ();
	BOOL IsData;
	HANDLE KF;
	CTray* KeyTray;
	CDelArray Deleted; 
	CNames Names;
	void* BuildRKey (char* key);
	void EnterDir (char* name);
	void LoadKeys ();
	BOOL RemoveFileEl (HANDLE hFile,DWORD Inx,int sizef,DWORD* elsize);
	BOOL BuildTray ();


public:
	~CGsiDB();
	CGsiDB (char *name);
	
	// TODO: add your methods here.
	CArrayPtr* GetKeys();
	BOOL Get (char* key,DWORD* data);
	BOOL GetLN (DWORD key,char* data);
	char* GetEN (DWORD key);
	BOOL Add (CInData indata);
	BOOL Delete (char* key);
	BOOL DeleteLN (DWORD key,char* word);
	char* DeleteEN (DWORD key);
	BOOL Qwery (char* key);
	

};





