#include <string.h>
#include <iostream.h>
#include <fstream.h>

class CCatalog {
private:

	struct CNode {
		CNode * pNext;
		char * name;
		int nNum;
	};

private:

	CNode * pTop;
	int nCount;
	ifstream input;
	ofstream output;
	

public:

	CCatalog ( void );
	void DoIt ( void );

private:

	void ADD ( void );
	void FS ( void );
	void FN ( void );
	void FL ( void );
	void DS ( void );
	void DN ( void );
	void DL ( void );
	void ERROR ( void );

};

CCatalog::CCatalog ( void ) : input ( "catalog.inp", ios::in ), output ( "catalog.out", ios::out ) {

	pTop = NULL;
	nCount = 0;

}

void CCatalog::DoIt ( void ) {

	char command[256];

	while ( input.get ( command, 256, ' ' ) ) {

		if ( strcmp ( command, "ADD" ) == 0 )

			ADD ();

		else if ( strcmp ( command, "FS" ) == 0 )

			FS ();

		else if ( strcmp ( command, "FN" ) == 0 )

			FN ();

		else if ( strcmp ( command, "FL" ) == 0 )

			FL ();

		else if ( strcmp ( command, "DS" ) == 0 )

			DS ();

		else if ( strcmp ( command, "DN" ) == 0 )

			DN ();

		else if ( strcmp ( command, "DL" ) == 0 )

			DL ();

		else

			ERROR ();

	}

	CNode * p;

	while ( pTop != NULL ) {
		p = pTop;
		pTop = pTop->pNext;
		delete [] p->name;
		delete p;
	}

}

void CCatalog::ADD ( void ) {

	input.get ();
	CNode * pNode = new CNode;
	pNode->name = new char [256];
	input.getline ( pNode->name, 256, '\n' );
	pNode->nNum = ++nCount;
	pNode->pNext = NULL;
	int c;

	if ( nCount > 2 ) {
		CNode * p = pTop;
		while ( ( c = strcmp ( p->name, pNode->name ) ) < 0 && p->pNext != NULL )
			p = p->pNext;
		if ( c < 0 )
			p->pNext = pNode;
		else if ( c > 0 ) {
			pNode->pNext = p->pNext;
			p->pNext = pNode;
			int i;
			char * pc;
			i = p->nNum;
			p->nNum = pNode->nNum;
			pNode->nNum = i;
			pc = p->name;
			p->name = pNode->name;
			pNode->name = pc;
			pNode = p;
		}
	}
	else if ( nCount == 2 ) {
		c = strcmp ( pTop->name, pNode->name );
		if ( c < 0 )
			pTop->pNext = pNode;
		else if ( c > 0 ) {
			pNode->pNext = pTop;
			pTop = pNode;
		}
	}
	else {
		pTop = pNode;
		c = -1;
	}

	if ( c == 0 ) {
		output << "DUPLICATES NOT ALLOWED" << endl;
		--nCount;
		delete [] pNode->name;
		delete pNode;
	}
	else
		output << "ADDED: " << pNode->name << endl;

}

void CCatalog::FS ( void ) {

	input.get ();
	char param[256];
	input.getline ( param, 256, '\n' );
	CNode * p = pTop;
	while ( p != NULL && strcmp ( p->name, param ) != 0 )
		p = p->pNext;
	if ( p != NULL )
		output << "FOUND: " << p->nNum << endl;
	else
		output << "NOT FOUND" << endl;

}

void CCatalog::FN ( void ) {

	int n;
	input >> n;
	CNode * p = pTop;

	while ( p != NULL && n != p->nNum )
		p = p->pNext;
	if ( p != NULL )
		output << "FOUND: " << p->name << endl;
	else
		output << "NOT FOUND" << endl;

	char tmp[256];
	input.getline ( tmp, 256, '\n' );

}

void CCatalog::FL ( void ) {

	int n;
	input >> n;
	CNode * p = pTop;

	if ( n > nCount )
		output << "NOT FOUND" << endl;
	else {
		int i;
		for ( i = 1; i < n; ++i )
			p = p->pNext;
		output << "FOUND: " << p->name << endl;
	}

	char tmp[256];
	input.getline ( tmp, 256, '\n' );

}

void CCatalog::DS ( void ) {

	input.get ();
	char param[256];
	input.getline ( param, 256, '\n' );
	CNode * p = pTop;
	while ( p != NULL && strcmp ( p->name, param ) != 0 )
		p = p->pNext;
	if ( p != NULL ) {
		output << "DELETED: " << p->nNum << endl;
		int n = p->nNum;
		if ( p == pTop ) {
			pTop = pTop->pNext;
		}
		else {
			CNode * q = pTop;
			while ( q->pNext != p )
				q  = q->pNext;
			q->pNext = p->pNext;
		}
		delete [] p->name;
		delete p;
		p = pTop;
		while ( p != NULL ) {
			if ( p->nNum > n )
				--p->nNum;
			p = p->pNext;
		}
		--nCount;
	}
	else
		output << "NOT FOUND" << endl;

}

void CCatalog::DN ( void ) {

	int n;
	input >> n;
	CNode * p = pTop;

	while ( p != NULL && n != p->nNum )
		p = p->pNext;
	if ( p != NULL ) {
		output << "DELETED: " << p->name << endl;
		int n = p->nNum;
		if ( p == pTop ) {
			pTop = pTop->pNext;
		}
		else {
			CNode * q = pTop;
			while ( q->pNext != p )
				q  = q->pNext;
			q->pNext = p->pNext;
		}
		delete [] p->name;
		delete p;
		p = pTop;
		while ( p != NULL ) {
			if ( p->nNum > n )
				--p->nNum;
			p = p->pNext;
		}
		--nCount;
	}
	else
		output << "NOT FOUND" << endl;

	char tmp[256];
	input.getline ( tmp, 256, '\n' );

}

void CCatalog::DL ( void ) {

	int n;
	input >> n;
	CNode * p = pTop;

	if ( n > nCount )
		output << "NOT FOUND" << endl;
	else {
		int i;
		for ( i = 1; i < n; ++i )
			p = p->pNext;
		output << "DELETED: " << p->name << endl;
		int n = p->nNum;
		if ( p == pTop ) {
			pTop = pTop->pNext;
		}
		else {
			CNode * q = pTop;
			while ( q->pNext != p )
				q  = q->pNext;
			q->pNext = p->pNext;
		}
		delete [] p->name;
		delete p;
		p = pTop;
		while ( p != NULL ) {
			if ( p->nNum > n )
				--p->nNum;
			p = p->pNext;
		}
		--nCount;
	}

	char tmp[256];
	input.getline ( tmp, 256, '\n' );

}

void CCatalog::ERROR ( void ) {

	char param[256];
	input.getline ( param, 256, '\n' );
	output << "SYNTAX ERROR" << endl;

}

void main ( void ) {

	CCatalog obj;
	obj.DoIt ();

}