{
 /===============================================\
 |                                               |
 |          Ivan Aleksandrov Stanishev           |
 |              18 g, gr. Gabrovo                |
 |                                               |
 |                   uchenik v                   |
 |   TMET 'D-r Nikola Vasiliadi' - gr. Gabrovo   |
 |                                               |
 \===============================================/
}
program CATALOG;
uses windows;
Const NOMERA = 'nomera.dta';

 type TItem = record
        nm : String;
        pn : LongInt;
      end;
      TFileItem = record
        nm : String[250];
        pn : LongInt;
      end;
      FTItem = file of TFileItem;

 var dt : array[1..63,0..25000] of TItem;
     ad : array[1..100000] of TItem;
     cc : array[1..63] of LongInt;
     Infile, OutFile : TEXT;
     s : String;
     AllCount : LongInt;
     mainf : FTItem;
     WorkWithFiles : Boolean;

function GetN( ch: Char ): Byte;
 begin
   If ch in ['0'..'9'] then GetN := Ord( ch ) - 47
   else if ch in ['A'..'Z'] then GetN := Ord( ch ) - 54
        else GetN := Ord( ch ) - 60;
 end;

function GetNM( i : Byte ): String;
 begin
  if i in [1..10] then GetNM := Chr( i+47 ) + '.dta'
  else if i in [11..36] then GetNM := Chr( i+ 54 ) + '0.dta'
       else GetNM := Chr( i + 60 ) + '1.dta';
 end;

{=============================================================== }
{ BEGIN files fucntions ======================================== }
{=============================================================== }

procedure InitFiles;
  var f : FTItem;
      i,j : LongInt;
      t : TFileItem;
 begin
   For i := 1 to 63 do
     if cc[i] <> 0 then
      begin
        Assign( f, GetNM( i ) ); ReWrite( f );
        for j := 1 to cc[i] do
          begin
            t.nm := dt[i,j].nm;
            t.pn := dt[i,j].pn;
            Write( f, t );
          end;
        Close( f );
      end;
   Assign( f, NOMERA ); ReWrite( f );
   for i := 1 to allCount do
      begin
        t.nm := ad[i].nm;
        t.pn := ad[i].pn;
        write( f, t );
      end;
   Close( f );
 end;

function f_BinSearch( ind: LongInt; name : String ) : LongInt;
   var f : FTItem;
       M, L, R : LongInt;
       tmp, Li,Ri : TFileItem;
  begin
   Assign( f, GetNM( ind ) );
   L := 0; R := cc[ind];
   if L=R then begin f_BinSearch := 0; exit; end;
   Reset( f );
   while ( L < R ) do
     begin
       M := ( L + R ) div 2;
       Seek( f, M ); Read( f, tmp );
       if name < tmp.nm then R := M
          else if name > tmp.nm then L := M
          else
            begin
              f_BinSearch := -(M+1);
              Close( f );
              exit;
            end;
       if L+1 = R then break;
     end;
   Seek( f, L ); Read( f, Li );
   if name < Li.nm then f_BinSearch := L
   else if name > Li.nm then f_BinSearch := L+1
   else f_BinSearch := -L-1;
 end;

procedure f_Add( name : String );
  var ps,ind,i : LongInt;
      t, tmp : TFileItem;
      f : FTItem;
 begin
   ind := GetN( name[1] ); AllCOunt := AllcOunt + 1;
   t.nm := name; t.pn := AllCount;
   Assign( f, NOMERA );
   If AllCOunt = 0 then ReWrite( f ) else Reset( f );
   Seek( f , AllCount-1 ); Write( f, t ); Close( f );
   if cc[ind] = 0 then
     begin
       cc[ind] := 1;
       Assign( f, GetNM( ind ) ); ReWrite( f );
       write( f, t ); close( f );
       writeln( outfile, 'ADDED: ' + name );
     end
   else
     begin
       ps := f_BinSearch( ind, name );
       if ps < 0 then writeln( outfile, 'DUPLICATES NOT ALLOWED' )
       else
         begin
           Assign( f, GetNM( ind ) ); Reset( f );
           for i := cc[ind]-1 downto ps do
             begin
               Seek( f, i );
               Read( f, tmp );
               write( f, tmp );
             end;
           Seek( f, ps );
           write( f, t );
           cc[ind] := cc[ind] + 1;
           writeln( outfile, 'ADDED: ' + name );
           close( f );
         end;
     end;
 end;

procedure f_ReCalc( t : TFileItem );
  var ind, ps : LongInt;
      f : FTItem;
 begin
  ind := GetN( t.nm[1] );
  ps := f_BinSearch( ind, t.nm );
  Assign( f, GetNM( ind ) ); Reset( f );
  Seek( f, -ps-1 ); Write( f, t );
  Close( f );
 end;

procedure f_Remove( t : TFileItem );
   var i, ind, step : LongInt;
       tmp : TFileItem;
       f : FTItem;
 begin
  ind := GetN( t.nm[1] ); step := 0;
  Assign( f, GetNM( ind ) ); Reset( f );
  cc[ind] := cc[ind] - 1;
  for i := 0 to cc[ind] do
    begin
     Seek( f , i ); Read( f, tmp );
     if tmp.pn < t.pn then Continue;
     if tmp.pn > t.pn then Dec( tmp.pn )
        else begin step := 1; continue; end;
     Seek( f, i-step );
     Write( f, tmp );
    end;
  Close( f );
 end;

procedure f_DN( n : LongInt; PRN : Boolean );
  var i : LongInt;
      tmp, t : TFileItem;
      f : FTItem;
 begin
  if (n < 0) or (n >= AllCount) then
     begin Writeln( outfile, 'NOT FOUND' ); exit; end;
  Assign( f, NOMERA ); Reset( f );
  Seek( f, n );
  Read( f, t );
  f_Remove( t );
  AllCount := AllCount - 1;
  for i := n+1 to allCount do
    begin
     Seek( f, i );
     Read( f, tmp );
     Dec( tmp.pn );
     if t.nm[1] <> tmp.nm[1] then f_ReCalc( tmp );
     Seek( f, i-1 );
     Write( f, tmp );
    end;
  Close( f );
  If PRN then writeln( outfile, 'DELETED: ' + t.nm );
 end;

procedure f_DL( n: LongInt );
  var ind, a : LongInt;
      f : FTItem;
      t : TFileItem;
 begin
   if (n<=0) or (n > ALlcount) then
     begin writeln( outfile, 'NOT FOUND' ); exit; end;
   ind := 1; a  := n;
   while a > cc[ind] do
     begin
      a := a-cc[ind];
      ind := ind + 1;
     end;
   if a=0 then begin Dec(ind); a:=cc[ind]; end;
   Assign( f, GetNM(ind) ); Reset( f );
   seek( f, a-1 ); Read( f, t ); Close( f );
   f_DN( t.pn-1, FALSE );
   writeln( outfile, 'DELETED: ' + t.nm );
 end;

procedure f_DS( s : String );
   var ps : LongInt;
       f : FTItem;
       t : TFIleItem;
 begin
   ps := f_BinSearch( GetN(s[1]), s );
   if ps >=0 then Writeln( outfile, 'NOT FOUND' )
   else
     begin
       Assign( f, GetNM( GetN( s[1] ) ) ); Reset( f );
       Seek( f, -ps-1 ); Read( f, t );
       f_DN( t.pn-1, FALSE );
       writeln( outfile, 'DELETED: ', t.pn );
       Close( f );
     end;
 end;

 procedure f_FN( n : LongInt );
    var f : FTItem;
        t : TFileItem;
   begin
     if (n < 0) or (n>=AllCount) then
        begin writeln( outfile, 'NOT FOUND' ); exit end;
     Assign( f, NOMERA ); Reset( f );
     Seek( f, n ); Read( f, t );
     writeln( outfile, 'FOUND: ' + t.nm );
     Close( f );
   end;

 procedure f_FL( n : LongInt );
    var a,i,ind : LongInt;
        f : FTItem;
        t : TFileItem;
   begin
     if ( n<=0 ) or (n>AllcOunt) then
        begin writeln( outfile, 'NOT FOUND' ); exit end;
     a := n; ind := 1;
     while a > cc[ind] do
       begin
         a := a - cc[ind];
         ind := ind + 1;
       end;
     if a=0 then begin ind:=ind-1; a:=cc[ind]; end;
     Assign( f, GetNM( ind ) ); Reset( f );
     Seek( f, a-1 ); Read( f, t );
     writeln( outfile, 'FOUND: ' + t.nm );
   end;

 procedure f_FS( s : String  );
   var ps, ind : LongInt;
       t : TFileItem;
       f : FTItem;
  begin
    ind := GetN( s[1] );
    ps := f_BinSearch( ind, s );
    if ps >= 0 then writeln( outfile, 'NOT FOUND' )
    else
     begin
       Assign( f, GetNM( ind ) ); Reset( f );
       Seek( f, -ps-1 ); Read( f, t );
       writeln( outfile, 'FOUND: ', t.pn );
     end;
  end;

{=============================================================== }
{ END   files fucntions ======================================== }
{=============================================================== }

function BinSearch( ind : LongInt; fname : String ) : LongInt;
  var L, R : LongInt;
      tmp : TItem;
 begin
   BinSearch := -1;
   R := CC[ind];L := 0;
   while (L < R) do
     begin
       tmp := dt[ ind, (l+R) div 2 ];
       if fname < tmp.nm then R := (L+R) div 2;
       if fname > tmp.nm then L := (L+R) div 2;
       if fname = tmp.nm then
          begin
             BinSearch := ((L+R) div 2)*(-1);
             exit;
          end;
       if L+1 = R then break;
     end;
   If (L=0)and(R<>0) then
      begin
        tmp := dt[ind,R];
        if fname > tmp.nm then BinSearch := 1;
        If fname < tmp.nm then BinSearch := 0;
        if fname = tmp.nm then BinSearch := -1;
      end
   else If (dt[ind,L].nm=fname) then BinSearch := -L
        else If (dt[ind,R].nm=fname) then BinSearch := -R
             else if (L < R) then BinSearch := L
                             else BinSearch := R;
 end;


procedure Add( nm : String );
   var ps, i, ind : LongInt;
       item : TItem;
 begin
   item.nm := nm;
   ind := GetN( nm[1] );
   ps := BinSearch( ind, nm );
   if ps < 0 then writeln( outfile, 'DUPLICATES NOT ALLOWED' )
   else
    begin
      writeln( outfile, 'ADDED: ' + nm );
      ps := ps+1;
        for i := cc[ind] downto ps do
         dt[ind,i+1] := dt[ind,i];
      cc[ind] := cc[ind] + 1;
      AllCount := AllCount + 1;
      item.pn := AllCount;
      dt[ ind,ps ] := item;
      ad[ AllCount ] := item;
      if (AllCount = 100000) or (cc[ind] = 25000 ) then
                 WorkWithFiles := true;
    end;
 end;

procedure FN( n: LongInt );
 begin
   if (n<1) or (N>AllCount) then writeln( outfile, 'NOT FOUND' )
   else writeln( outfile, 'FOUND: ' + ad[n].nm );
 end;

procedure FL( n: LongInt );
  var a, i : LongInt;
 begin
   if (n<1) or (n>allCount) then writeln( outfile, 'NOT FOUND' )
   else
    begin
      a := n; i := 1;
      while (a > cc[i]) and (a>0) do
         begin
           a := a - cc[i];
           i := i+1;
         end;
      if a=0 then begin i:=i-1; a := cc[i]; end;
      writeln( outfile, 'FOUND: ' + dt[i,a].nm )
    end;
 end;

procedure FS( s : String );
  var ps, i : LongInt;
 begin
   i := GetN( s[1] );
   ps := BinSearch( i, s );
   if ps >= 0 then writeln( outfile,  'NOT FOUND' )
   else
     begin
       ps := -ps;
       writeln( outfile, 'FOUND: ', dt[i,ps].pn );
     end;
 end;

procedure DN( n : LongInt; PRN : Boolean );
   var s : String;
       i,j,k : LongInt;
 begin
   if (n<1) or (n>allCount) then writeln( outfile, 'NOT FOUND' )
    else
    begin
       s := ad[ n ].nm;
       if PRN then writeln( outfile, 'DELETED: ' + s );
       for i := n to AllCount do
          ad[i] := ad[i+1];
       AllCount := AllCount - 1;
       for i := 1 to 63 do
         for j := 1 to cc[i] do
           if dt[i,j].pn > n then Dec( dt[i,j].pn )
           else if dt[i,j].pn < n then Continue
           else {if dt[i,j].pn=n then}
             begin
               for k := j to cc[i] do
                begin
                  dt[i,k] := dt[i,k+1];
                  if dt[i,k].pn > n then Dec( dt[i,k].pn );
                end;
               cc[i] := cc[i] - 1;
               break;
             end;
    end;
 end;

procedure DL( n : LongInt );
   var a,i : LongInt;
  begin
   if (n<1) or (n>allCount) then writeln( outfile, 'NOT FOUND' )
    else
     begin
       a := n; i := 1;
       while cc[i] < a do
          begin
            a := a - cc[i];
            i := i+1;
          end;
       if a=0 then begin i:=i-1; a := cc[i]; end;
       DN( dt[i,a].pn, TRUE );
     end;
  end;

procedure DS( s : String );
  var ps, i : LongInt;
      p : String;
 begin
   i := GetN(s[1]);
   ps := BinSearch( i, s );
   if ps >= 0 then writeln( outfile, 'NOT FOUND' )
   else
     begin
       writeln( outfile, 'DELETED: ', dt[i,-ps].pn );
       DN( dt[i,-ps].pn, FALSE );
     end;
 end;

 var a : LongInt;
     code : Integer;
BEGIN
 WorkWithFiles := false;
 Assign( infile , 'catalog.inp'  ); Reset( infile );
 Assign( outfile, 'catalog.out' ); ReWrite( outfile );
 while (not eof( infile ))and(not WorkWithFiles) do
   begin
     readln( infile, s );
     if s <> '' then
       begin
         if pos('ADD ',s)=1 then begin Add( Copy(s,5,255) );                         Continue; end;
         if pos('FN ' ,s)=1 then begin val( Copy(s,4,255), a, code ); FN( a );       Continue; end;
         if pos('FL ' ,s)=1 then begin val( Copy(s,4,255), a, code ); FL( a );       Continue; end;
         if pos('FS ' ,s)=1 then begin  FS( Copy(s,4,255) );                         Continue; end;
         if pos('DN ' ,s)=1 then begin val( Copy(s,4,255), a, code ); DN( a, TRUE ); Continue; end;
         if pos('DL ' ,s)=1 then begin val( Copy(s,4,255), a, code ); DL( a );       Continue; end;
         if pos('DS ' ,s)=1 then begin  DS( Copy(s,4,255) );                         Continue; end;
         writeln( outfile, 'SYNTAX ERROR' );
       end;
   end;

 if WorkWithFiles then
 begin
  InitFiles;
  while not eof( infile ) do
   begin
     readln( infile, s );
     if s <> '' then
       begin
         if pos('ADD ',s)=1 then begin f_Add( Copy(s,5,255) );                          Continue; end;
         if pos('FN ' ,s)=1 then begin val( Copy(s,4,255), a, code ); f_FN( a-1 );      Continue; end;
         if pos('FL ' ,s)=1 then begin val( Copy(s,4,255), a, code ); f_FL( a );        Continue; end;
         if pos('FS ' ,s)=1 then begin  f_FS( Copy(s,4,255) );                          Continue; end;
         if pos('DN ' ,s)=1 then begin val( Copy(s,4,255), a, code ); f_DN( a-1, TRUE ); Continue end;
         if pos('DL ' ,s)=1 then begin val( Copy(s,4,255), a, code ); f_DL( a );        Continue; end;
         if pos('DS ' ,s)=1 then begin  f_DS( Copy(s,4,255) );                          Continue; end;
         writeln( outfile, 'SYNTAX ERROR' );
       end;
   end;
   DeleteFile( NOMERA );
   for a := 1 to 63 do
       DeleteFile(  PChar( GetNM( a ) ) );
 end;
 Close( infile ); Close( outfile );
END.
