/* Martin Petkov Ruskov/18/Sofia/uchenik */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define WORD_LEN 251
#define MAX 1000

#define sign( a ) ( a < 0 ? -1 : a > 0 )

int max = MAX;
char **word;
unsigned long n;
unsigned long *p;

unsigned long search( char name[] )
{
  int t, k = 1;
  unsigned long i;
  
  for( i = 0; i < n; i++ )
  {
    t = sign( strcmp( name, word[i] ));
    if( !t ) return i;
    if( t != k )
      return max + i;
    k = t;
  }
  
  return max + i;
}

int main()
{
  int flag = 0;
  char cmd[WORD_LEN];
  char name[WORD_LEN];
  unsigned long num;
  unsigned long t, i, j, k;

  p = malloc( max * sizeof( unsigned long ));
  word = malloc( max * sizeof( char* ));
  for( i = 0; i < max; i++ )
    word[i] = malloc( WORD_LEN );

  freopen( "CATALOG.INP", "r", stdin );
  freopen( "CATALOG.OUT", "w", stdout );

  for(;;)
  {
    scanf( "\n%[^\n]s", cmd );

    if( feof( stdin ) )
    {
      fclose( stdin );
      fclose( stdout );
      for( i = 0; i < max; i++ )
        free( word[i] );
      free( word );
      free( p );
      return 0;
    }
    if( !strncmp( cmd, "ADD ", 4 ) )
    {
    if( n == max - 5 )
      {
        k = max;
        max += MAX;
        p = realloc( p, max * sizeof( unsigned long ));
        word = realloc( word, max * sizeof( char* ));
        for( i = k; i < max; i++ )
          word[i] = malloc( WORD_LEN );
      }
      sscanf( cmd, "ADD %[^\n]s", name );
      t = search( name );
      if( t < max )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "DUPLICATES NOT ALLOWED" );
      }
      else
      {
        for( i = t - max, k = ++n; i < n; i++ )
        {
          j = p[i], p[i] = k, k = j;
          strcpy( cmd, word[i] );
          strcpy( word[i], name );
          strcpy( name, cmd );
        }
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "ADDED: %s", word[t - max] );
      }
      continue;
    }
    if( !strncmp( cmd, "FS ", 3 ) )
    {
      sscanf( cmd, "FS %[^\n]s", name );
      t = search( name );
      if( t < max )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "FOUND: %lu", p[t] );
      }
      else
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      continue;
    }
    if( !strncmp( cmd, "FN ", 3 ) )
    {
      sscanf( cmd, "FN %lu", &num );
      if( num > n || num < 1 )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      else
        for( i = 0; i < n; i++ )
          if( p[i] == num )
          {
            if( flag )
              printf( "\n" );
            else
              flag = 1;
            printf( "FOUND: %s", word[i] );
            break;
          }
      continue;
    }
    if( !strncmp( cmd, "FL ", 3 ) )
    {
      sscanf( cmd, "FL %lu", &num );
      if( num > n || num < 1 )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      else
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "FOUND: %s", word[num - 1] );
      }
      continue;
    }
    if( !strncmp( cmd, "DS ", 3 ) )
    {
      sscanf( cmd, "DS %[^\n]s", name );
      t = search( name );
      if( t <= max )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "DELETED: %lu", p[t] );
        k = p[t];
        for( i = t; i < n; i++ )
        {
          strcpy( word[i], word[i + 1] );
          p[i] = p[i + 1];
        }
        for( i = 0 ;i < n; i++ )
          if( p[i] > k ) p[i]--;
        n--;
      }
      else
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      continue;
    }
    if( !strncmp( cmd, "DN ", 3 ) )
    {
      sscanf( cmd, "DN %lu", &num );
      if( num > n || num < 1 )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      else
        for( i = 0; i < n; i++ )
          if( p[i] == num )
          {
            if( flag )
              printf( "\n" );
            else
              flag = 1;
            printf( "DELETED: %s", word[i] );
            for( j = i; j < n; j++ )
            {
              strcpy( word[j], word[j + 1] );
              p[j] = p[j + 1];
            }
            for( j = 0 ;j < n; j++ )
              if( p[j] > num ) p[j]--;
            n--;
            break;
          }
      continue;
    }
    if( !strncmp( cmd, "DL ", 3 ) )
    {
      sscanf( cmd, "DL %lu", &num );
      if( num > n || num < 1 )
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "NOT FOUND" );
      }
      else
      {
        if( flag )
          printf( "\n" );
        else
          flag = 1;
        printf( "DELETED: %s", word[num - 1] );
        k = p[num - 1];
        for( i = num - 1; i < n; i++ )
        {
          strcpy( word[i], word[i + 1] );
          p[i] = p[i + 1];
        }
        for( i = 0 ;i < n; i++ )
          if( p[i] > k ) p[i]--;
        n--;
      }
      continue;
    }
    if( flag )
      printf( "\n" );
    else
      flag = 1;
    printf( "SYNTAX ERROR" );
  }

}
