{Copyright (c) Peter Sabev, 2000}
{e-mail: psabev@bulgaria.com}

program CATALOG;
{$APPTYPE CONSOLE}
uses
  SysUtils;

const fin='CATALOG.INP';
      fon='CATALOG.OUT';

type TItem=record
           name:string;
           lex:longint;
           end;

var a:array of TItem;
    n:longint;
    fi,fo:Text;

procedure Add(s:string);
var dupl:boolean;
    lex,i:longint;
begin
if (s[1]=' ') or (s[length(s)]=' ') then writeln(fo,'SYNTAX ERROR') else
begin
lex:=n+1;
dupl:=false;
for i:=1 to n do
begin
if s=a[i].name then dupl:=true;
if s<a[i].name then dec(lex);
end;
if dupl then writeln(fo,'DUPLICATES NOT ALLOWED') else
begin
writeln (fo,'ADDED: ',s);
inc(n);
a[n].name:=s;
a[n].lex:=lex;
for i:=1 to n-1 do
if a[i].lex>=a[n].lex then inc(a[i].lex);
end;
end;
end;

procedure FindString(s:String);
var i:longint;
    found:boolean;
begin
i:=0;
found:=false;
repeat
inc(i);
if a[i].name=s then found:=true;
until (i=n) or found;
if found then writeln(fo,'FOUND: ',i) else writeln(fo,'NOT FOUND');
end;

procedure FindNumber(s:String);
var v,k:longint;
begin
val(s,v,k);
if k<>0 then writeln(fo,'SYNTAX ERROR') else
begin
if v>n then writeln(fo,'NOT FOUND') else
writeln(fo,'FOUND: ',a[v].name);
end;
end;

procedure FindLex(s:String);
var found:boolean;
    i,v:longint;
begin
val(s,v,i);
if i<>0 then writeln(fo,'SYNTAX ERROR') else
begin
found:=false;
repeat
inc(i);
if a[i].lex=v then found:=true;
until (i=n) or found;
if found then writeln(fo,'FOUND: ',a[i].name) else writeln(fo,'NOT FOUND');
end;
end;

procedure Del(x:longint);
var i:longint;
begin
for i:=1 to n do
if (i<>x) and (a[i].lex>a[x].lex) then dec(a[i].lex);
for i:=x to n do
a[i]:=a[i+1];
dec(n);
end;

procedure DelString(s:String);
var i:longint;
    found:boolean;
begin
i:=0;
found:=false;
repeat
inc(i);
if a[i].name=s then found:=true;
until (i=n) or found;
if found then begin
writeln(fo,'DELETED: ',i);
del(i);
end else writeln(fo,'NOT FOUND');
end;

procedure DelNumber(s:String);
var v,k:longint;
begin
val(s,v,k);
if k<>0 then writeln(fo,'SYNTAX ERROR') else
begin
if v>n then writeln(fo,'NOT FOUND') else
begin
writeln(fo,'DELETED: ',a[v].name);
Del(v);
end;
end;
end;

procedure DelLex(s:String);
var found:boolean;
    i,v:longint;
begin
val(s,v,i);
if i<>0 then writeln(fo,'SYNTAX ERROR') else
begin
found:=false;
repeat
inc(i);
if a[i].lex=v then found:=true;
until (i=n) or found;
if found then begin
writeln(fo,'DELETED: ',a[i].name);
Del(i);
end else writeln(fo,'NOT FOUND');
end;
end;

procedure Calculate_It;
var s:string;
begin
readln(fi,s);
{ADD}
if (s[1]='A') and (s[2]='D') and (s[3]='D') and (s[4]=' ') then Add(copy(s,5,length(s)-4)) else
{FS}
if (s[1]='F') and (s[2]='S') and (s[3]=' ') then FindString(copy(s,4,length(s)-3)) else
{FN}
if (s[1]='F') and (s[2]='N') and (s[3]=' ') then FindNumber(copy(s,4,length(s)-3)) else
{FL}
if (s[1]='F') and (s[2]='L') and (s[3]=' ') then FindLex(copy(s,4,length(s)-3)) else
{DS}
if (s[1]='D') and (s[2]='S') and (s[3]=' ') then DelString(copy(s,4,length(s)-3)) else
{DN}
if (s[1]='D') and (s[2]='N') and (s[3]=' ') then DelNumber(copy(s,4,length(s)-3)) else
{DL}
if (s[1]='D') and (s[2]='L') and (s[3]=' ') then DelLex(copy(s,4,length(s)-3)) else
{Command not recognized}
writeln(fo,'SYNTAX ERROR');
end;

procedure Check_It;
var s:string;
begin
n:=1;
repeat
  readln(fi,s);
  if pos('ADD ',s)=1 then inc(n);
  until eof(fi);
end;

begin
  assign(fi,fin);
  assign(fo,fon);
  n:=0;
  reset(fi);
  Check_It;
  close(fi);
  reset(fi);
  rewrite(fo);
  SetLength(a,n);
  n:=0;
  repeat
  Calculate_It;
  until eof(fi);
  close(fi);
  close(fo);
end.