// Reshenie na zadacha 1 na Peter Kormushev
#include <stdio.h>
#include <alloc.h>
#include <string.h>

typedef char* keytype;

#define RED 'R'
#define BLACK 'B'

struct node {
       keytype key;
       char color;
       unsigned long size;
       struct node *left, *right, *p;
       struct node *equals;
};

struct node nil = { NULL /* "NULL" */,BLACK,0,NULL,NULL,NULL,NULL };  // size=0
		// NULL e parent->key na root-a;
struct node *nilt = &nil;

void Left_Rotate(struct node **root,struct node *x)
{
struct node *y;

   y=x->right;
   x->right = y->left;
   if (y->left!=nilt) (y->left)->p = x;
   y->p = x->p;
   if (x->p == nilt) *root=y;
	       else if (x== (x->p)->left)  (x->p)->left = y;
                    else (x->p)->right = y;

   y->left = x;
   x->p = y;
   y->size = x->size;
   x->size = x->left->size + x->right->size + 1;
}

void Right_Rotate(struct node **root, struct node *y)
{
struct node *x;

   x=y->left;
   y->left = x->right;
   if (x->right !=nilt) (x->right)->p = y;
   x->p = y->p;
   if (y->p == nilt) *root=x;
               else if (y== (y->p)->right)  (y->p)->right = x;
                    else (y->p)->left = x;

   x->right = y;
   y->p = x;
   x->size = y->size;
   y->size = y->left->size + y->right->size + 1;

}

struct node *Tree_Search (struct node *x, keytype k)
{
int i;
   if (x==nilt) return NULL;  // not found

   i = strcmp(k,x->key);
   if (i==0) return x;  // equal strings - found

   if (i < 0) return Tree_Search(x->left,k);
	    else   return Tree_Search(x->right,k);
}

struct node *Tree_Minimum(struct node *x)
{
   while (x->left!=nilt) x=x->left;
   return x;
}

struct node *Tree_Successor(struct node *x)
{
struct node *y;

   if (x->right!=nilt) return Tree_Minimum(x->right);
   y=x->p;
   while ( (y!=nilt) && (x==y->right)) { x=y; y=y->p; }
   return y;
}

struct node *OS_Select (struct node *x, unsigned long i)  // return i-th order statistic
		 // returns the i-th smallest key(node) in the subtree rooted at x
{
unsigned long r = x->left->size + 1;

   if (i==r) return x;
   else if (i<r) return OS_Select(x->left,i);
	else return OS_Select(x->right,i-r);
}

unsigned long OS_Rank (struct node *root, struct node *x)  // returns the rank of x in linear order
{
unsigned long r = x->left->size + 1;
struct node *y = x;
if (x==NULL) return 0;
	while (y != root)
	{
	     if (y==y->p->right) r += y->p->left->size + 1;
	     y=y->p;
	}
	return r;
}

struct node *Create_Node(keytype k)   // allocate memory for node
{
   struct node *z;
   z = (struct node *) malloc(sizeof(struct node));

   z->key = k;
   z->size=1;  // prepared to be a leaf
   z->left = z->right = nilt;
   return z;
}

void Release_Node(struct node *z)   // de-allocate memory for node
{
   if (z!=NULL) free(z);
}

struct node *Tree_Insert(struct node **root, struct node *z)
{
   struct node *x, *y;

   y=nilt;
   x=*root;
   while (x!=nilt)
   {
	 x->size ++;
	 y=x;
	 if (strcmp(z->key,x->key)<0) x=x->left;        // key compare
		 else    x=x->right;
   }
   z->p = y;
   if (y==nilt) *root=z;
   else if (strcmp(z->key,y->key)<0) y->left = z;         // key compare
	else y->right = z;

   return z;   // returns ptr to the inserted node

}

struct node *RB_Insert(struct node **root, struct node *z)
{
   struct node *x,*y;
   x = Tree_Insert(root,z);  // x=z

   x->color = RED;

   while ( (x!=*root) && ((x->p)->color == RED))
   {
      if ((x->p) == ((x->p)->p)->left)
      {
	 y = ((x->p)->p)->right;
	 if (y->color == RED)
	 {
	    (x->p)->color = BLACK;
	    y->color = BLACK;
	    ((x->p)->p)->color = RED;
	    x = (x->p)->p;
	 }
	 else
	 {    if (x==(x->p)->right)
	      {
		 x= x->p;
		 Left_Rotate(root,x);
	      };
	      (x->p)->color = BLACK;
	      ((x->p)->p)->color = RED;
	      Right_Rotate(root,(x->p)->p);
	 };
      }
      else

      {
	 y = ((x->p)->p)->left;
	 if (y->color == RED)
	 {
	    (x->p)->color = BLACK;
	    y->color = BLACK;
	    ((x->p)->p)->color = RED;
	    x = (x->p)->p;
	 }
	 else
	 {    if (x==(x->p)->left)
	      {
		 x= x->p;
		 Right_Rotate(root,x);
	      };
	      (x->p)->color = BLACK;
	      ((x->p)->p)->color = RED;
	      Left_Rotate(root,(x->p)->p);
	 };
      };

   } // while
   (*root)->color = BLACK;

   return z;   // returns ptr to the inserted node
}

// inserts the given node to the most right in the tree, regardless of its key
// using the trick that any other node key being compared is < char(255)
struct node *RB_Insert_Last(struct node **root, struct node *z)
{
unsigned char biggest[]={255,0};
char *c;
// biggest[0]==255 - zatova otiva nakraja

    c=z->key;
    z->key=biggest;
    RB_Insert(root,z);
    z->key=c;
    return z;
}

void RB_Delete_Fixup(struct node **root, struct node *x)
{
   struct node *w;

   while ( (x!=*root) && (x->color == BLACK))

   {
      if (x == (x->p)->left)
      {
	 w=(x->p)->right;
	 if (w->color == RED)
	 {
            w->color = BLACK;
            (x->p)->color = RED;
	    Left_Rotate(root,x->p);
            w=(x->p)->right;
	 };
         if ( ((w->left)->color == BLACK) && ((w->right)->color == BLACK) )
         {
            w->color = RED;
	    x= x->p;
         }
         else
         {
              if ((w->right)->color == BLACK)
              {
                 (w->left)->color = BLACK;
                 w->color = RED;
                 Right_Rotate(root,w);
                 w=(x->p)->right;
              };
              w->color = (x->p)->color;
              (x->p)->color = BLACK;
              (w->right)->color = BLACK;
              Left_Rotate(root,x->p);
              x=*root;
         };

      }
      else
      {
         w=(x->p)->left;
         if (w->color == RED)
	 {
            w->color = BLACK;
            (x->p)->color = RED;
            Right_Rotate(root,x->p);
            w=(x->p)->left;
         };
         if ( ((w->right)->color == BLACK) && ((w->left)->color == BLACK) )
         {
            w->color = RED;
            x= x->p;
	 }
	 else
	 {
	      if ((w->left)->color == BLACK)
	      {
		 (w->right)->color = BLACK;
		 w->color = RED;
		 Left_Rotate(root,w);
		 w=(x->p)->left;
	      };
	      w->color = (x->p)->color;
	      (x->p)->color = BLACK;
	      (w->left)->color = BLACK;
	      Right_Rotate(root,x->p);
	      x=*root;
	 };

      };

   } // while
   x->color = BLACK;

}

void Dec_sizes(struct node *x)
{
 while (x != nilt )   // stoppes after decreasing root size
 {
    x->size --;
    x=x->p;
 };
}

struct node *RB_Delete(struct node **root, struct node *z)


{
   struct node *x, *y;

   if (z==NULL) return NULL; // the key does not exit

//   if (z->key != NULL) free(z->key); // release key memory - NO, TOO RISKY
// we leave memory releasing to the user !!!

   if ( (z->left==nilt) || (z->right == nilt) )
	y=z;
   else
       y=Tree_Successor(z);

   Dec_sizes(y->p); // fixes sizes

   if (y->left != nilt) x=y->left;
      else      x=y->right;

   x->p = y->p;

   if (y->p == nilt) *root=x;
	    else if (y==(y->p)->left) (y->p)->left = x;
		 else (y->p)->right = x;
   if (y!=z)
   {
	z->key = y->key;             // key compare/copy
   // if y has other fields, copy them too here...

	z->equals = y->equals;       // added !!!!
	y->equals->equals = z;       // added !!!! fixes/reconnects equals

   };

   if (y->color == BLACK)
      RB_Delete_Fixup(root,x);

   return y; // returns pointer to the deleted node (MAY NOT BE the same as first z)
}
