#include <stdlib.h>
#include <stdio.h>
#include <fstream>
#include <string>
#include <map>

string add (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	string name;
	getline (fi, name);
	if (m2.find(name) != m2.end()) return string("DUPLICATES NOT ALLOWED");
	int num = m1.size() + 1;
	m1[num] = name;
	m2[name] = num;
	string result("ADDED: ");
	result += name;
	return result;
}

string fs (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	string name;
	getline (fi, name);
   map<string, int>::iterator it;
	it = m2.find(name);
	if (it==m2.end()) return string("NOT FOUND");

	string result("FOUND: ");
	char s[200];
	itoa(it->second, s, 10);
	result = result + string(s);

	return result;
}

string fn (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	int num; string dummy;
	fi >> num;
	getline (fi, dummy);
   map<int, string>::iterator it;
	it = m1.find(num);
	if (it==m1.end()) return string("NOT FOUND");

	string result("FOUND: ");
	result += it->second;

	return result;
}

string fl (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	int num; string dummy;
	fi >> num;
	getline (fi, dummy);
	if (num > m2.size()) throw "NOT FOUND";

	string result("FOUND: ");
	map<string, int>::iterator it = m2.begin();
   for (int i=1; i<=num-1; i++, it++) {};
	result += it->first;

	return result;
}

string ds (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	string name;
	getline (fi, name);
   map<string, int>::iterator it;
	it = m2.find(name);
	if (it==m2.end()) return string("NOT FOUND");

	string result("DELETED: ");
	char s[200];
	itoa(it->second, s, 10);
	result = result + string(s);

   int num = it->second;
   int total = m2.size();
   m2.erase(it);
   m1.erase(num);

   string cur_name;
   for (int i=num+1; i<=total; i++) {
   	cur_name = m1[i];
      m1.erase(i); m1[i-1] = cur_name;
      m2.erase(cur_name); m2[cur_name] = i-1;
   }
   return result;
}

string dn (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	int num; string dummy;
	fi >> num;
	getline (fi, dummy);
   map<int, string>::iterator it;
	it = m1.find(num);
	if (it==m1.end()) return string("NOT FOUND");

	string result("DELETED: ");
	result += it->second;

   string name = it->second;
   int total = m1.size();
   m1.erase(it);
   m2.erase(name);
   string cur_name;
   for (int i=num+1; i<=total; i++) {
   	cur_name = m1[i];
      m1.erase(i); m1[i-1] = cur_name;
      m2.erase(cur_name); m2[cur_name] = i-1;
   }
	return result;
}

string dl (ifstream &fi, map<int, string> &m1, map<string, int> &m2)
{
	int num; string dummy;
	fi >> num;
	getline (fi, dummy);
	if (num > m2.size()) throw "NOT FOUND";

	string result("DELETED: ");
	map<string, int>::iterator it = m2.begin();
   for (int i=1; i<=num-1; i++, it++) {};
	result += it->first;

   num = it->second;
   int total = m2.size();
   m2.erase(it);
   m1.erase(num);
   string cur_name;
   for (int i=num+1; i<=total; i++) {
   	cur_name = m1[i];
      m1.erase(i); m1[i-1] = cur_name;
      m2.erase(cur_name); m2[cur_name] = i-1;
   }
	return result;
}

int main() {

	ifstream fi;
	ofstream fo;

	try {

   fi.open("catalog.inp");
//   	throw "INPUT FILE NOT FOUND";
   fo.open("catalog.out");
//   	throw 0;

   map<int, string> m1;
   map<string, int> m2;

   typedef pair<string, string (*)(ifstream&, map<int, string>&, map<string, int>&)> cmdtype;

   cmdtype cmds_def[7] = {
   	cmdtype("ADD", add),
      cmdtype("FS", fs),
      cmdtype("FN", fn),
      cmdtype("FL", fl),
      cmdtype("DS", ds),
      cmdtype("DN", dn),
      cmdtype("DL", dl)
   };

   map<string, string (*)(ifstream &, map<int, string>&, map<string, int>&) >
   	cmds (&cmds_def[0], &cmds_def[7]);

   string command;
   string result;
	string dummy;
	char space;

   while (fi.peek()!=EOF) {
		try {
         fi >> command;
			fi.get();
			if (command.empty()) break;

			if (cmds.find(command) == cmds.end()) {
				getline(fi, dummy);
				throw "SYNTAX ERROR";
			}

	   	result = (cmds[command])(fi, m1, m2);
   	   fo << result << endl;
		}

		catch (char const * msg) {
			fo << msg << endl;
		}
   }

   fi.close();
   fo.close();

	} //try

   catch (char const * msg) {
		printf ("ERROR: %s\n", msg);
   }
   catch (int error) {
   	printf ("ERROR: %d\n", error);
	}

   return 0;
}

