#include <stdio.h>
#include <string.h>
#include <stdlib.h>

long int N;
struct articul{
	char* name;
	articul *nnext,*lnext,*nprev,*lprev;
};

int comandType(char* s){
	switch(s[0]){
		case 'A':
			if(s[1]!='D'||s[2]!='D'||s[3]!=' ')
			return 0;
			return 1;                            //ADD
		case 'F':
			if(s[2]!=' ')return 0;
			if(s[1]=='S')return 2;               //FS
			if(s[1]=='N')return 3;               //FN
			if(s[1]=='L')return 4;               //FL
			return 0;
		case 'D':
         if(s[2]!=' ')return 0;
			if(s[1]=='S')return 5;               //DS
			if(s[1]=='N')return 6;               //DN
			if(s[1]=='L')return 7;               //DL
			return 0;
		default:
			return 0;
	}
}

int isName(char* s){
	if((*s<'A'||*s>'Z')&&(*s<'a'||*s>'z')&&(*s<'0'||*s>'9'))
		return 0;
	s++;
	while(*s!='\n'&&*s!='\0'){
   	if((*s<'A'||*s>'Z') && (*s<'a'||*s>'z') && (*s<'0'||*s>'9') && *s!=' ')
			return 0;
		s++;
	}
	if(*(s-1)==' ')
		return 0;
	*s='\0';
	return 1;
}

long int isaNumber(char* s){
	long int n;
	if(*s<'0'||*s>'9')
		return -1;
   n=*s-'0';
   s++;
	while(*s!='\n'&&*s!='\0'){
		if(*s<'0'||*s>'9')
			return 0;
      n=10*n-'0'+*s;
		s++;
	}
	*s='\0';
	return n;
}

int strComp(const char* s1,const char* s2){
	do{
		if(*s1>*s2) return 1;
		if(*s1<*s2) return -1;
		s1++;s2++;
	}while(*s1!='\0');
	if(*s2=='\0') return 0;
	return -1;
}

void Add(const char* s,articul &x,FILE *fp){
	articul *nart;     //new artucul
	if(x.lnext==NULL){
		nart=new articul;
		x.lnext=nart;
		nart->lnext=NULL;
		nart->lprev=&x;
		x.nnext=nart;
		nart->nnext=NULL;
		nart->nprev=&x;
		nart->name=new char[strlen(s)+1];
		strcpy(nart->name,s);
	}
	else{
		articul *temp=x.lnext;
		while(strComp(s,temp->name)<0 && temp->lnext!=NULL)
			temp=temp->lnext;
		
		if(strComp(s,temp->name)==0){
			fprintf(fp,"DUPLICATES NOT ALLOWED\n");
			return;
		}
		if(temp->lnext==NULL && strComp(s,temp->name)<0){
			nart=new articul;
			temp->lnext=nart;
			nart->lnext=NULL;
			nart->lprev=temp;
			nart->name=new char[strlen(s)+1];
			strcpy(nart->name,s);
		}
		else{
			nart=new articul;
			nart->lnext=temp;
			nart->lprev=temp->lprev;
			temp->lprev->lnext=nart;
			temp->lprev=nart;
			nart->name=new char[strlen(s)+1];
			strcpy(nart->name,s);
		}
	nart->nnext=x.nnext;
	nart->nprev=&x;
	x.nnext->nprev=nart;
	x.nnext=nart;
	}
   N++;
	fprintf(fp,"ADDED: %s\n",s);
}

void Fs(const char *s,articul &x,FILE* fp){
	articul *temp;
	for(temp=x.lnext;temp!=NULL;temp=temp->lnext)
		if(strComp(s,temp->name)>=0)
			break;
	if(temp==NULL || strComp(s,temp->name)>0)
		fprintf(fp,"NOT FOUND\n");
	else{
		long int i=N;
		for(articul *iter=x.nnext;iter!=temp;iter=iter->nnext,i--);
		fprintf(fp,"FOUND: %ld\n",i);
	}
}

void Fn(long int n,articul &x,FILE* fp){
	if(N<n)
		fprintf(fp,"NOT FOUND\n");
	else{
		articul *temp;
      long int i=N;
		for(temp=x.nnext;i!=n;temp=temp->nnext,i--);
		fprintf(fp,"FOUND: %s\n",temp->name);
	}
}

void Fl(long int n,articul &x,FILE* fp){
	if(N<n)
		fprintf(fp,"NOT FOUND\n");
	else{
		articul *temp;
      long int i=N;
		for(temp=x.lnext;i!=n;temp=temp->lnext,i--);
		fprintf(fp,"FOUND: %s\n",temp->name);
	}
}

void Ds(char *s,articul &x,FILE *fp){
	articul *fir;
	for(fir=x.lnext;fir!=NULL;fir=fir->lnext)
		if(strComp(fir->name,s)<=0)
			break;
	if(fir==NULL||strComp(fir->name,s)<0)
		fprintf(fp,"NOT FOUND\n");
	else{
   	articul *temp=x.nnext;
		long int i=N;
		for(;temp!=fir;temp=temp->nnext,i--);
		fir->lprev->lnext=fir->lnext;
		if(fir->lnext)
			fir->lnext->lprev=fir->lprev;
		fir->nprev->nnext=fir->nnext;
		if(fir->nnext)
			fir->nnext->nprev=fir->nprev;
		N--;
		fprintf(fp,"DELETED: %ld\n",i);
		delete fir->name;
		delete fir;
	}
}

void Dn(long int n,articul &x,FILE *fp){
	if(n>N)
		fprintf(fp,"NOT FOUND\n");
	else{
		articul *temp=x.nnext;
		long int i=N;
		for(;i!=n;i--,temp=temp->nnext);
		temp->lprev->lnext=temp->lnext;
		if(temp->lnext)
      	temp->lnext->lprev=temp->lprev;
		temp->nprev->nnext=temp->nnext;
		if(temp->nnext)
      	temp->nnext->nprev=temp->nprev;
      N--;
		fprintf(fp,"DELETED: %s\n",temp->name);
		delete temp->name;
		delete temp;
	}
}

void Dl(long int n,articul &x,FILE *fp){
	if(n>N)
		fprintf(fp,"NOT FOUND\n");
	else{
		articul *temp=x.lnext;
		long int i=N;
		for(;i!=n;i--,temp=temp->lnext);
		temp->lprev->lnext=temp->lnext;
		if(temp->lnext)
      	temp->lnext->lprev=temp->lprev;
		temp->nprev->nnext=temp->nnext;
		if(temp->nnext)
      	temp->nnext->nprev=temp->nprev;
      N--;
		fprintf(fp,"DELETED: %s\n",temp->name);
		delete temp->name;
		delete temp;
	}
}

void main(){
	FILE *f1,*f2;
	if((f1=fopen("CATALOG.INP","r"))==NULL){
		printf("ERROR1!\n");
		exit(1);
	}
	if((f2=fopen("CATALOG.OUT","w"))==NULL){
		printf("ERROR2!\n");
		exit(1);
	}
	char s[252];
	long int n;
	articul fund;
	fund.nnext=fund.lnext=NULL;
//   fund.name=NULL;
	N=0;
	while(fgets(s,252,f1)!=NULL){
		switch(comandType(s)){
			case 1:if(isName(s+4)==0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Add(s+4,fund,f2);
					 break;
			case 2:if(isName(s+3)==0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Fs(s+3,fund,f2);
					 break;
			case 3:n=isaNumber(s+3);
					 if(n<=0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Fn(n,fund,f2);
					 break;
			case 4:n=isaNumber(s+3);
         		 if(n<=0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Fl(n,fund,f2);
					 break;
			case 5:if(isName(s+3)==0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Ds(s+3,fund,f2);
					 break;
			case 6:n=isaNumber(s+3);
					 if(n<=0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Dn(n,fund,f2);
					 break;
			case 7:n=isaNumber(s+3);
					 if(n<=0)
						 fprintf(f2,"SYNTAX ERROR\n");
					 else
						 Dl(n,fund,f2);
					 break;
			default:
				fprintf(f2,"SYNTAX ERROR\n");
		}
	}
	fclose(f1); fclose(f2);
	articul *temp;
	while(fund.nnext!=NULL){
		temp=fund.nnext;
		fund.nnext=temp->nnext;
		delete temp->name;
		delete temp;
	}
}