#include "Catalog.h"
#include <iostream>


bool Catalog::Add(const string str, bool dirty){
	int sz = size()+1;//true index of added element;
	STRINT::value_type addpair(str,pair<int,int>(sz,0));
	pair<STRINT::iterator,bool> itpair = m_container.insert(addpair);
	STRINT::iterator it = itpair.first;
	if(itpair.second==false&&(*it).second.first>0) return false;
	if((*it).second.first<0)//Virtually deleted before
		(*it).second.first = sz;
	m_ind.push_back(&(*it).first);
	if(m_container.size()<minDirty||m_DelBuffer.size()>maxDirty||m_DelBufferL.size()>maxDirty) dirty = false;
	//if(!dirty)
		m_dirty = true;
	//else//To do
	return true;
}

//Gets true index out of "dirty" one (used by dirty Find)
inline int Catalog::trueIndex(int ind,const PAIRLIST& DelBuffer) const{
	if(DelBuffer.size()==0) return ind;
	PAIRLIST::iterator it = DelBuffer.begin();
	int delta = 0;
	while(it!=DelBuffer.end()&&(*it).second<ind){
		delta += (*it).second - (*it).first +1;
		++it;
	}
	ind -= delta;
	return ind;
}

//Gets true index out of "dirty" one
//and refreshes the list with deleted intervals (used by dirty Del)
inline int Catalog::trueIndexW(int ind,PAIRLIST& DelBuffer){
	PAIRLIST::iterator it = DelBuffer.begin();
	int delta = 0;
	while(it!=DelBuffer.end()&&(*it).second<ind){
		delta += (*it).second - (*it).first +1;
		++it;
	}
	if(it==DelBuffer.end()&&DelBuffer.size()==0){//first delete
		pair<int,int> pr(ind,ind);
		DelBuffer.push_back(pr);
	}
	else
	if(it!=DelBuffer.end()&&ind==(*it).first-1){
		PAIRLIST::iterator curr = it;
		if(delta>0){
			--it;
			if(ind==(*it).second+1){//Merge two neighbor intervals:
				pair<int,int> pr((*it).first,(*curr).second);
				*it = pr;
				DelBuffer.erase(curr);
			}
			else
				--(*curr).first;
		}
		else
			--(*curr).first;
	}
	else{
		PAIRLIST::iterator curr = it;
		if(delta>0){
			--it;
			if(ind==(*it).second+1)//Extend preceeding interval from the right:
				++(*it).second;
			else{
				pair<int,int> pr(ind,ind);
				DelBuffer.insert(curr,pr);
			}
		}
		else{
			pair<int,int> pr(ind,ind);
			DelBuffer.insert(curr,pr);
		}
	}
	ind -= delta;
	return ind;
}

//Gets "dirty" index out of true one (used by dirty Find)
inline int Catalog::dirtyIndex(int ind,const PAIRLIST& DelBuffer) const{
	if(DelBuffer.size()==0) return ind;
	PAIRLIST::iterator it = DelBuffer.begin();
	int dirty = ind;//Dirty index
	while(it!=DelBuffer.end()&&(*it).first<=dirty){
		dirty += (*it).second - (*it).first +1;
		++it;
	}
	//if(ind<0)cout<<"Ind="<<ind<<endl;//Here OK
	return dirty;
}

//Gets "dirty" (valid) index out of true one
//and refreshes the list with deleted intervals (used by dirty Del)
inline int Catalog::dirtyIndexW(int ind,PAIRLIST& DelBuffer){
	PAIRLIST::iterator it = DelBuffer.begin();
	int dirty = ind;//Dirty index
	while(it!=DelBuffer.end()&&(*it).first<=dirty){
		dirty += (*it).second - (*it).first +1;
		++it;
	}
	if(it==DelBuffer.end()&&DelBuffer.size()==0){//first delete
		pair<int,int> pr(dirty,dirty);
		DelBuffer.push_back(pr);
	}
	else
	if(it!=DelBuffer.end()&&dirty==(*it).first-1){
		PAIRLIST::iterator curr = it;
		if(dirty>ind){
			--it;
			if(dirty==(*it).second+1){//Merge two neighbor intervals:
				pair<int,int> pr((*it).first,(*curr).second);
				*it = pr;
				DelBuffer.erase(curr);
			}
			else
				--(*curr).first;
		}
		else
			--(*curr).first;
	}
	else{
		PAIRLIST::iterator curr = it;
		if(dirty>ind){
			--it;
			if(dirty==(*it).second+1)//Extend preceeding interval from the right:
				++(*it).second;
			else{
				pair<int,int> pr(dirty,dirty);
				DelBuffer.insert(curr,pr);
			}
		}
		else{
			pair<int,int> pr(dirty,dirty);
			DelBuffer.insert(curr,pr);
		}
	}
	return dirty;
}

int Catalog::Del(const string str, bool dirty){
	//Force containers clean up:
	if(m_container.size()<minDirty||m_DelBuffer.size()>maxDirty||m_DelBufferL.size()>maxDirty) dirty = false;
	if(!dirty) RebuildAll();
	STRINT::iterator toDelIt = m_container.find(str);
	if(toDelIt==m_container.end()) return 0;//Nothing to delete;
	if(dirty&&(*toDelIt).second.first<1) return 0;//Already marked as deleted;
	int del_ind = (*toDelIt).second.first-1;
	int del_indL = (*toDelIt).second.second-1;
	if(dirty){
		(*toDelIt).second.first = -(*toDelIt).second.first;//Mark invalid entries by negative numbers;
		if(!m_dirty){
			m_DelCacheL.push_back(del_indL);
		}
		m_ind[del_ind] = 0;//Mark invalid index entry by NULL pointer;
		del_ind = trueIndexW(del_ind,m_DelBuffer);
		toDel++;
	}
	else{
		m_ind.erase(m_ind.begin()+del_ind);
		if(!m_dirty) m_indL.erase(m_indL.begin()+del_indL);//??
		m_container.erase(toDelIt);
		STRINT::iterator it = m_container.begin();
		while(it!=m_container.end()){
			if((*it).second.first>del_ind) (*it).second.first--;
			if(!m_dirty&&(*it).second.second>del_indL) (*it).second.second--;
			++it;
		}
		//m_dirty = true;
	}
	return del_ind+1;
}

string Catalog::Del(int i, bool dirty){
	if(i-1<0||i-1>=size()) return "";
	//Force containers clean up:
	//if(m_container.size()<minDirty||toDel>maxDirty) dirty = false;//Complexity of dirty op depends on size of m_delBuffer only, not of toDel!
	if(m_container.size()<minDirty||m_DelBuffer.size()>maxDirty) dirty = false;
	string str;
	clearDelCache();
	if(dirty){
		i = dirtyIndexW(i-1,m_DelBuffer);
		//if(m_ind[i]==0) {cout<<"Bad index "<<m_DelBuffer.front().second<<endl;exit(1);}//return "";//Already marked as deleted; Should not happen!!
		str = *m_ind[i];
		STRINT::iterator toDelIt = m_container.find(str);
		if(!m_dirty){
			m_DelCacheL.push_back((*toDelIt).second.second-1);
			//(*toDelIt).second.second = -(*toDelIt).second.second;//??
		}
		//if((*toDelIt).second.first<1) cout<<"Something wrong!"<<endl;
		(*toDelIt).second.first = -(*toDelIt).second.first;//Mark invalid entries by negative numbers;
		m_ind[i] = 0;//Mark invalid index entry by NULL pointer;
		toDel++;
	}
	else{
		RebuildAll();
		str = *m_ind[i-1];
		Del(str,false);
	}
	return str;
}

string Catalog::DelL(int i, bool dirty){
	if(i-1<0||i-1>=size()) return "";
	//Force containers clean up:
	//if(m_container.size()<minDirty||toDel>maxDirty) dirty = false;//Complexity of dirty op depends on size of m_delBuffer only, not of toDel!
	if(m_container.size()<minDirty||m_DelBufferL.size()>maxDirty) dirty = false;
	if(m_dirty) MakeIndexL();
	else clearDelCacheL();
	string str;
	if(dirty){
		i = dirtyIndexW(i-1,m_DelBufferL);
		str = *m_indL[i];
		STRINT::iterator toDelIt = m_container.find(str);
		m_DelCache.push_back((*toDelIt).second.first-1);//Dirty bug without -1!!!
		(*toDelIt).second.first = -(*toDelIt).second.first;//Mark invalid entries by negative numbers;
		m_indL[i] = 0;//Mark invalid index entry by NULL pointer;
		toDel++;
	}
	else {
		if(m_indL.size()!=size()) MakeIndexL();
		str = *m_indL[i-1];
		Del(str,false);
	}
	return str;
}

int Catalog::Find(const string str, bool dirty){
	STRINT::iterator it = m_container.find(str);
	if(it==m_container.end()||(*it).second.first<0) return 0;//Not found;
	clearDelCache();
	//clearDelCacheL();
	return trueIndex((*it).second.first,m_DelBuffer);
}

string Catalog::Find(int i, bool dirty){
	if(i-1<0||i-1>=size()) return "";
	if(m_container.size()<minDirty||dirtyFind>MaxDirtyFind()) dirty = false;
	clearDelCache();
	if(!dirty){
		if(m_ind.size()!=size()) MakeIndex();
		return *m_ind[i-1];
	}
	i = dirtyIndex(i-1,m_DelBuffer);
	dirtyFind++;
	return *m_ind[i];
}

string Catalog::FindL(int i, bool dirty){
	if(i-1<0||i-1>=size()) return "";
	if(m_container.size()<minDirty||dirtyFindL>MaxDirtyFind()) dirty = false;
	if(m_dirty) MakeIndexL();
	else clearDelCacheL();
	if(!dirty){
		if(m_indL.size()!=size()) MakeIndexL();
		return *m_indL[i-1];
	}
	i = dirtyIndex(i-1,m_DelBufferL);
	dirtyFindL++;
	return *m_indL[i];
}

void Catalog::MakeIndex(){
	if(m_ind.size()==size()) return;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Rebuilding index...";
	m_ind.resize(size());
	STRINT::iterator it = m_container.begin();
	while(it!=m_container.end()){
		if((*it).second.first>0){
			int dirty = (*it).second.first-1;
			(*it).second.first = trueIndex(dirty,m_DelBuffer)+1;
			m_ind[(*it).second.first-1] = &(*it).first;
		}
		++it;
	}
	m_DelBuffer.clear();
	m_DelCache.clear();
	//toDel = 0;
	dirtyFind = 0;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Done!"<<endl;
}

void Catalog::MakeIndexL(){
	if(m_indL.size()==size()) return;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Rebuilding Lex index...";
	m_indL.clear();
	STRINT::iterator it = m_container.begin();
	int i=0;
	while(it!=m_container.end()){
		if((*it).second.first>0){
			m_indL.push_back(&(*it).first);
			(*it).second.second = ++i;//Save Lex index
		}
		++it;
	}
	m_dirty = false;
	m_DelBufferL.clear();
	m_DelCacheL.clear();
	dirtyFindL = 0;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Done!"<<endl;
}

void Catalog::RebuildAll(){
	if(m_ind.size()==size()) return;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Rebuilding All...";
	STRINT::iterator it = m_container.begin();
	int i=0;
	clearDelCache();
	clearDelCacheL();
	m_indL.clear();
	m_ind.resize(size());
	while(it!=m_container.end()){
		if((*it).second.first<1){
			//STRINT::iterator temp = it;
			//++temp;
			it = m_container.erase(it);//?
			//it = temp;
		}
		else{
			m_indL.push_back(&(*it).first);
			int dirty = (*it).second.first-1;
			(*it).second.first = trueIndex(dirty,m_DelBuffer)+1;//Save true index
			m_ind.at((*it).second.first-1) = &(*it).first;
			(*it).second.second = ++i;//Save Lex true index
			++it;
		}
	}
	m_DelBufferL.clear();
	m_DelCacheL.clear();
	m_DelBuffer.clear();
	m_DelCache.clear();
	m_dirty = false;
	toDel = 0;
	dirtyFind = 0;
	dirtyFindL = 0;
	if(minDirty>=3000&&maxDirty>=3000)
	cout<<"Done!"<<endl;
}

inline void Catalog::clearDelCache(){
	if(m_DelCache.size()==0) return;
	INTLIST::iterator it = m_DelCache.begin();
	while(it != m_DelCache.end()){
		m_ind[*it] = 0;//Mark invalid index entry by NULL pointer;
		trueIndexW(*it++,m_DelBuffer);
	}
	m_DelCache.clear();
}

inline void Catalog::clearDelCacheL(){
	if(m_DelCacheL.size()==0) return;
	INTLIST::iterator it = m_DelCacheL.begin();
	while(it != m_DelCacheL.end()){
		m_indL[*it] = 0;//Mark invalid index entry by NULL pointer;
		trueIndexW(*it++,m_DelBufferL);
	}
	m_DelCacheL.clear();
}