#include <iostream>
#include <fstream>
#include <string>

#pragma warning(disable:4786)

using namespace std;

//Number of commands of different types:
static int AD, DS, DN, DL, FS, FN, FL;
static int SD;//Step in delete operations;

//********************************
//*   Parses Command Line String *
//********************************
void GetOpts(int& argc, char **argv)
{
	if (argc==1){
		cout<<"USAGE: MakeInp [AD# DS# DN# DL# FS# FN# FL#]"<<endl;
		cout<<"This will produce test file Catalog.inp with"<<endl;
		cout<<"corresponding numbers of different commands"<<endl<<endl;
    exit(0);
	}
	for (int OptNum = 1; OptNum < argc; OptNum++)
	{
		string str = strupr(argv[OptNum]);
		string i_str = str.substr(2);
		int i = atoi(i_str.c_str());
		//cout<<str<<endl;

		switch(str[0]){
	 		case 'A' :
	 			if(str[1]=='D') AD=i;
	 			break;
	 		case 'D' :
	 			if(str[1]=='S') DS=i;
	 			if(str[1]=='N') DN=i;
	 			if(str[1]=='L') DL=i;
	 			break;
	 		case 'F' :
	 			if(str[1]=='S') FS=i;
	 			if(str[1]=='N') FN=i;
	 			if(str[1]=='L') FL=i;
	 		case 'S' :
				SD = i;
	 	}
	}
}

int main(int argc, char *argv[]){
	string NameRoot = "Item No ";
	string str;
	GetOpts(argc, argv);
	int total = AD+DS+DN+DL+FS+FN+FL;
	ofstream os("Catalog.inp");
	if(!os){
		cout<<"Can not open Catalog.inp!"<<endl;
		exit(1);
	}
	char a[10];
	int curr = 0;
	for(int i=1; i<=AD;i++){
		str = "ADD "+NameRoot;
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=0; i<DS;i++){
		str = "DS "+NameRoot;
		itoa(i*(1+SD),a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=0; i<DN;i++){
		//str = "DN 1";
		str = "DN ";
		itoa(1+i*SD,a,10);//For realistic tests of batch deletes;
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=0; i<DL;i++){
		//str = "DL 1";
		str = "DL ";
		itoa(1+i*SD,a,10);//For realistic tests of batch deletes;
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FS;i++){
		str = "FS "+NameRoot;
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FN;i++){
		str = "FN ";
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FL;i++){
		str = "FL ";
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	os.close();
	return 0;
}