#include <math.h>
#include "miniSQL.h"

char* success_str[]={
"ADDED: ",
"DELETED: ",
"DELETED: ",
"DELETED: ",
"FOUND: ",
"FOUND: ",
"FOUND: "
};

char* fail_str[]={
"DUPLICATES NOT ALLOWED\n",
"NOT FOUND\n",
"NOT FOUND\n",
"NOT FOUND\n",
"NOT FOUND\n",
"NOT FOUND\n",
"NOT FOUND\n",
"SYNTAX ERROR\n"
};

command getCommand(const string str){
	if(str.size()<4) return ERR;
	switch(str[0]){
		case 'A' :
			if(str[1]=='D'&&str[2]=='D'&&str[3]==' ') return ADD;
			break;
		case 'D' :
			if(str[1]=='S'&&str[2]==' ') return DS;
			if(str[1]=='N'&&str[2]==' ') return DN;
			if(str[1]=='L'&&str[2]==' ') return DL;
			break;
		case 'F' :
			if(str[1]=='S'&&str[2]==' ') return FS;
			if(str[1]=='N'&&str[2]==' ') return FN;
			if(str[1]=='L'&&str[2]==' ') return FL;
			//break;
		//default:
	}
	return ERR;
}

string execute(string str,Catalog &cat,bool dirty){
	command comm = getCommand(str);
	if(comm==ERR) return fail_str[7];
	string arg = (comm==ADD)?str.substr(4):str.substr(3);
	if(arg.size()==0||arg[0]==' '||arg[arg.size()-1]==' ') return fail_str[7];
	int i_arg;// = atoi(arg.c_str());
	static char a_result[16];
	string s_result;
	int result;
	switch(comm){
		case ADD :
			return (cat.Add(arg))?success_str[0]+arg+"\n":fail_str[0];
		case DS :
			result = cat.Del(arg,dirty);
			itoa(result,a_result,10);
			s_result = a_result;
			return (result)?success_str[1]+s_result+"\n":fail_str[1];
		case DN :
			i_arg = atoi(arg.c_str());
			s_result = cat.Del(i_arg,dirty);
			return (s_result!="")?success_str[2]+s_result+"\n":fail_str[2];
		case DL :
			i_arg = atoi(arg.c_str());
			s_result = cat.DelL(i_arg,dirty);
			return (s_result!="")?success_str[3]+s_result+"\n":fail_str[3];
		case FS :
			result = cat.Find(arg);
			itoa(result,a_result,10);
			s_result = a_result;
			return (result)?success_str[4]+s_result+"\n":fail_str[4];
		case FN :
			i_arg = atoi(arg.c_str());
			s_result = cat.Find(i_arg);
			return (s_result!="")?success_str[5]+s_result+"\n":fail_str[5];
		case FL :
			i_arg = atoi(arg.c_str());
			s_result = cat.FindL(i_arg);
			return (s_result!="")?success_str[6]+s_result+"\n":fail_str[6];
		//default:
	}
	return fail_str[7];
}