#include "Catalog.h"

#ifdef USE_MAP

bool Catalog::Add(const string str){
	int sz = m_container.size()+1;
	STRINT::value_type addpair(str,sz);
	pair<STRINT::iterator,bool> itpair = m_container.insert(addpair);
	if(itpair.second==false) return false;
	STRINT::iterator it = itpair.first;
	m_ind.push_back(&(*it).first);
	m_dirtyL = true;
	return true;
}

int Catalog::Del(const string str){
	STRINT::iterator toDel = m_container.find(str);
	if(toDel==m_container.end()) return 0;//Nothing to delete;
	int del_ind = (*toDel).second-1;
	m_ind.erase(m_ind.begin()+del_ind);
	m_container.erase(toDel);
	STRINT::iterator it = m_container.begin();
	while(it!=m_container.end()){
		if((*it).second>del_ind) (*it).second--;
		it++;
	}
	m_dirtyL = true;
	return del_ind+1;
}

string Catalog::Del(int i){
	if(i-1<0||i-1>=m_ind.size()) return "";
	string str = *m_ind[i-1];
	Del(str);
	return str;
}

string Catalog::DelL(int i){
	if(i-1<0||i-1>=m_ind.size()) return "";
	if(m_dirtyL) MakeIndexL();
	string str = *m_indL[i-1];
	Del(str);
	return str;
}

int Catalog::Find(const string str){
	STRINT::iterator it = m_container.find(str);
	if(it==m_container.end()) return 0;//Not found;
	return (*it).second;
}

string Catalog::Find(int i){
	if(i-1<0||i-1>=m_ind.size()) return "";
	return *m_ind[i-1];
}

string Catalog::FindL(int i){
	if(i-1<0||i-1>=m_ind.size()) return "";
	if(m_dirtyL) MakeIndexL();
	return *m_indL[i-1];
}

void Catalog::MakeIndexL(){
	m_indL.clear();
	STRINT::iterator it = m_container.begin();
	while(it!=m_container.end()){
		m_indL.push_back(&(*it).first);
		it++;
	}
	m_dirtyL = false;
}

#else
//Todo

bool Catalog::Add(const string str){
	return true;
}

int Catalog::Del(const string str){
	return true;
}

string Catalog::Del(int){
	return true;
}

string Catalog::DelL(int){
	return true;
}

int Catalog::Find(const string){
	return true;
}

string Catalog::Find(int){
	return "";
}

string Catalog::FindL(int){
	return "";
}

#endif