#ifndef CATALOG_H
#define CATALOG_H

#pragma warning(disable:4786)

#define USE_MAP

#include <string>
#include <vector>
#ifdef USE_MAP
#include <map>
#endif

using namespace std;

#ifdef USE_MAP
typedef map<string,int,less<string> > STRINT;
#else
typedef vector<string> VECTSTR;
typedef vector<int> VECTIND;
#endif

class Catalog{
public:
#ifdef USE_MAP
	Catalog():m_container(),m_ind(),m_indL(),m_dirty(false),m_dirtyL(false){};
#else
#endif
	bool Add(const string);
	int Del(const string);
	string Del(int);
	//bool Del(int ind,int num);
	string DelL(int);
	//bool DelL(int ind,int num);
	int Find(const string);
	string Find(int);
	string FindL(int);
	void MakeIndexL();
//private:
#ifdef USE_MAP
	STRINT m_container;//main container
	vector <const string*> m_ind;//index vector
	vector <const string*> m_indL;//Lex index vector
	bool m_dirty;//Dirty index
	bool m_dirtyL;//Dirty Lex index
#else
 VECTSTR m_container;//main container
 VECTSTR m_ind;//index vector
 bool m_dirty;//Dirty index
#endif
};

#endif