#include <iostream>
#include <fstream>
#include <string>

#pragma warning(disable:4786)

using namespace std;

//Default values of commands of different types:
//int AD=10000, DS=1000, DN=1000, DL=1000, FS=10000, FN=10000, FL=10000;
static int AD, DS, DN, DL, FS, FN, FL;

//********************************
//*   Parses Command Line String *
//********************************
void GetOpts(int& argc, char **argv)
{
	if (argc==1){
		cout<<"USAGE: MakeInp [AD# DS# DN# DL# FS# FN# FL#]"<<endl;
		cout<<"This will produce test file Catalog.inp with"<<endl;
		cout<<"corresponding numbers of different commands"<<endl<<endl;
    exit(0);//return;
	}
	for (int OptNum = 1; OptNum < argc; OptNum++)
	{
		string str = strupr(argv[OptNum]);
		string i_str = str.substr(2);
		int i = atoi(i_str.c_str());
		//cout<<str<<endl;

		switch(str[0]){
	 		case 'A' :
	 			if(str[1]=='D') AD=i;
	 			break;
	 		case 'D' :
	 			if(str[1]=='S') DS=i;
	 			if(str[1]=='N') DN=i;
	 			if(str[1]=='L') DL=i;
	 			break;
	 		case 'F' :
	 			if(str[1]=='S') FS=i;
	 			if(str[1]=='N') FN=i;
	 			if(str[1]=='L') FL=i;
	 	}
	}
}

int main(int argc, char *argv[]){
	string NameRoot = "Item No ";
	string str;
	GetOpts(argc, argv);
	int total = AD+DS+DN+DL+FS+FN+FL;
	ofstream os("Catalog.inp");
	if(!os){
		cout<<"Can not open Catalog.inp!"<<endl;
		exit(1);
	}
	char a[10];
	int curr = 0;
	for(int i=1; i<=AD;i++){
		str = "ADD "+NameRoot;
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=DS;i++){
		str = "DS "+NameRoot;
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=DN;i++){
		//str = "DN ";
		//itoa(i,a,10);
		//str +=a;
		str = "DN 1";
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=DL;i++){
		//str = "DL ";
		//itoa(i,a,10);
		//str +=a;
		str = "DL 1";
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FS;i++){
		str = "FS "+NameRoot;
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FN;i++){
		str = "FN ";
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	for(i=1; i<=FL;i++){
		str = "FL ";
		itoa(i,a,10);
		str +=a;
		if(++curr<total)str +="\n";
		os<<str;
	}
	os.close();
	return 0;
}