/***********************************************************
 *
 *   File:       timer.h
 *   Created:    05/04/99 6:24:PM
 *   Author:     V.Molotkov
 *   Comments:   Routines for measuring of time duration
 *               of various processes
 *
 ************************************************************
 *
 * History: Originally was part of author's version of
 * Mastermind  game (1977)
 *
 * ToDo:
 *
 ************************************************************/

#include <ctime>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#pragma warning(disable:4786)

using namespace std;

//***************
// Class timer: *
//***************
class timer {
private:
  time_t tmp;
public:
  time_t sec;
  time_t total_sec;
  timer(int s = 0, int ts = 0):
    sec(s),
    total_sec(ts),
    tmp(time(0)){}
  time_t get(){ return time(0) - tmp; }
  time_t get_total(){ return total_sec + time(0) - tmp; }
  void fix(){
    sec = time(0) - tmp;
    total_sec += sec;
    tmp = time(0);
  }
  void reset(){
    sec = 0;
    tmp = time(0);
  }
  void print(ostream &os){
    if (total_sec / 60 != 0 )
    os << (short)total_sec / 60 << "min.";
    os << (short)total_sec % 60 << "sec.";
  }
};

//